/*******************************************************************************
 * Copyright (c) 2007, 2010 Oracle. All rights reserved.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0, which accompanies this distribution
 * and is available at http://www.eclipse.org/legal/epl-v10.html.
 * 
 * Contributors:
 *     Oracle - initial API and implementation
 ******************************************************************************/
package org.eclipse.jpt.jpa.core.context;

/**
 * JPA attribute mapping that has a fetch type (e.g. basic, relationship).
 * <p>
 * Provisional API: This interface is part of an interim API that is still
 * under development and expected to change significantly before reaching
 * stability. It is available at this early stage to solicit feedback from
 * pioneering adopters on the understanding that any code that uses this API
 * will almost certainly be broken (repeatedly) as the API evolves.
 * 
 * @version 2.2
 * @since 2.0
 */
public interface FetchableMapping
	extends AttributeMapping
{
	FetchType getFetch();
		
	FetchType getSpecifiedFetch();
	void setSpecifiedFetch(FetchType newSpecifiedFetch);
		String SPECIFIED_FETCH_PROPERTY = "specifiedFetch"; //$NON-NLS-1$
	
	FetchType getDefaultFetch();
		String DEFAULT_FETCH_PROPERTY = "defaultFetch"; //$NON-NLS-1$
}
